#include "StdAfx.h"
#include "MusicItem.h"

/****************************************************************/
/*					O[oϐiNXǁEEEj		*/
/****************************************************************/
extern	OPSW*			cOptionSW;	//IvVւ̃|C^ϐ

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		const		wchar_t	_strName[]	IuWFNg
//	Ԓl
//				
//==============================================================
MusicItem::MusicItem(const wchar_t _strName[]):
	iOffset(0),
	strName(_strName)
{
	//Debug message@io͂̂ŒӁBj
	if(cOptionSW->cDebug & 0x01){
		wcout << L"Create Music Object : " << strName << endl;
	}
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MusicItem::~MusicItem(void)
{
	//----------------------
	//Localϐ
	vector<	MusicItem*>::iterator	itItem;

	//----------------------
	//Delete Class
	if(!ptcItem.empty()){
		itItem = ptcItem.begin();
		while(itItem != ptcItem.end()){
			delete *itItem;
			itItem++;
		}
		ptcItem.clear();
	}
}

//==============================================================
//		R[hTCY̎擾
//--------------------------------------------------------------
//	
//				
//	Ԓl
//		size_t
//==============================================================
size_t		MusicItem::getSize()
{
	return(iSize);
}

//==============================================================
//		R[h̃ItZbgAhX̎擾
//--------------------------------------------------------------
//	
//				
//	Ԓl
//		unsigned	int	
//==============================================================
unsigned	int		MusicItem::getOffset()
{
	return(iOffset);
}

//==============================================================
//		ItZbgAhX̐ݒ
//--------------------------------------------------------------
//	
//		unsigned	int		_offset
//	Ԓl
//				
//==============================================================
unsigned	int		MusicItem::SetOffset(unsigned	int _offset)
{
	//----------------------
	//Localϐ
	vector<	MusicItem*>::iterator	itItem;

	//Debug message@io͂̂ŒӁBj
	if(cOptionSW->cDebug & 0x02){
		wcout << L"Object Address [0x" << hex << _offset << dec << L"]: " << strName << endl;
	}

	iOffset = _offset;
	_offset	+= (unsigned int)code.size();

	if(!ptcItem.empty()){
		itItem = ptcItem.begin();
		while(itItem != ptcItem.end()){
			_offset = (*itItem)->SetOffset(_offset);
			itItem++;
		}
	}

	return(_offset);
}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		unsigned	int	n	Y
//	Ԓl
//		unsigned	char	e
//==============================================================
unsigned	char	MusicItem::getCode(int n)
{
	unsigned	char	iCode;
	
	if((n<0) || (n>iSize)){
		iCode = -1;
	} else {
		iCode = code[n];
	}

	return(iCode);
}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		string*		_str
//	Ԓl
//				
//==============================================================
void	MusicItem::getCode(string* _str)
{
	//----------------------
	//Localϐ
	vector<	MusicItem*>::iterator	itItem;

	_str->append(code);

	if(!ptcItem.empty()){
		itItem = ptcItem.begin();
		while(itItem != ptcItem.end()){
			(*itItem)->getCode(_str);
			itItem++;
		}
	}
}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		MusicFile*	MUS		R[ho͂ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	MusicItem::getAsm(MusicFile* MUS)
{
	//----------------------
	//Localϐ
	unsigned	int	i = 0;
	vector<	MusicItem*>::iterator	itItem;

	if(code.size() > 0){
		while(i < code.size()){
			if(i==0){
				*MUS << "	.byte	$";
			} else {
				*MUS << " ,$";
			}
			*MUS << hex << setw(2) << setfill('0') << (int)(code[i] & 0xFF);
			i++;
		}
		*MUS << dec << endl;
	}

	if(!ptcItem.empty()){
		itItem = ptcItem.begin();
		while(itItem != ptcItem.end()){
			(*itItem)->getAsm(MUS);
			itItem++;
		}
	}
}
